/* Copyright INRIA 2004
**
** This file is part of the Scotch distribution.
**
** The Scotch distribution is libre/free software; you can
** redistribute it and/or modify it under the terms of the
** GNU Lesser General Public License as published by the
** Free Software Foundation; either version 2.1 of the
** License, or (at your option) any later version.
**
** The Scotch distribution is distributed in the hope that
** it will be useful, but WITHOUT ANY WARRANTY; without even
** the implied warranty of MERCHANTABILITY or FITNESS FOR A
** PARTICULAR PURPOSE. See the GNU Lesser General Public
** License for more details.
**
** You should have received a copy of the GNU Lesser General
** Public License along with the Scotch distribution; if not,
** write to the Free Software Foundation, Inc.,
** 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
**
** $Id$
*/
/************************************************************/
/**                                                        **/
/**   NAME       : hmesh_order_hx.h                        **/
/**                                                        **/
/**   AUTHOR     : Francois PELLEGRINI                     **/
/**                                                        **/
/**   FUNCTION   : This module contains the data declara-  **/
/**                tions for the halo mesh block Approxi-  **/
/**                mate (Multiple) Minimum Degree and Fill **/
/**                ordering routines.                      **/
/**                                                        **/
/**   DATES      : # Version 4.0  : from : 09 dec 2003     **/
/**                                 to     09 dec 2003     **/
/**                                                        **/
/************************************************************/

/*
**  The defines.
*/

#define HMESHORDERHXHASHPRIME       17            /* Prime number */

/*
**  The type and structure definitions.
*/

/*+ A table made of such elements is used to compute
    the external degree of non-halo vertices.        +*/

typedef struct HmeshOrderHxHash_ {
  Gnum                      vertnum;              /*+ Origin vertex (i.e. pass) number +*/
  Gnum                      vertend;              /*+ End vertex number in mesh        +*/
} HmeshOrderHxHash;

/*
**  The function prototypes.
*/

#ifndef HMESH_ORDER_HX
#define static
#endif

int                         hmeshOrderHxFill    (const Hmesh * restrict const, Gnum * restrict const, Gnum * restrict const, Gnum * restrict const, Gnum * restrict const, Gnum * restrict const);

#undef static
